org.apache.commons.math3.random

## Class AbstractWell

- java.lang.Object
- - org.apache.commons.math3.random.BitsStreamGenerator
  - - org.apache.commons.math3.random.AbstractWell

- All Implemented Interfaces:
    Serializable, RandomGenerator
  Direct Known Subclasses:
    Well1024a, Well19937a, Well19937c, Well44497a, Well44497b, Well512a

      public abstract class AbstractWell
      extends BitsStreamGenerator
      implements Serializable

  This abstract class implements the WELL class of pseudo-random number generator from François Panneton, Pierre L'Ecuyer and Makoto Matsumoto.

  This generator is described in a paper by François Panneton, Pierre L'Ecuyer and Makoto Matsumoto Improved Long-Period Generators Based on Linear Recurrences Modulo 2 ACM Transactions on Mathematical Software, 32, 1 (2006). The errata for the paper are in wellrng-errata.txt.

  Since:
    2.2
  Version:
    $Id: AbstractWell.java 1416643 2012-12-03 19:37:14Z tn $
  See Also:
    WELL Random number generator, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int[]` | `i1` Index indirection table giving for each index the value index + m1 taking table size into account.
    `protected int[]` | `i2` Index indirection table giving for each index the value index + m2 taking table size into account.
    `protected int[]` | `i3` Index indirection table giving for each index the value index + m3 taking table size into account.
    `protected int` | `index` Current index in the bytes pool.
    `protected int[]` | `iRm1` Index indirection table giving for each index its predecessor taking table size into account.
    `protected int[]` | `iRm2` Index indirection table giving for each index its second predecessor taking table size into account.
    `private static long` | `serialVersionUID` Serializable version identifier.
    `protected int[]` | `v` Bytes pool.

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractWell(int k, int m1, int m2, int m3)` Creates a new random number generator.
    `protected` | `AbstractWell(int k, int m1, int m2, int m3, int seed)` Creates a new random number generator using a single int seed.
    `protected` | `AbstractWell(int k, int m1, int m2, int m3, int[] seed)` Creates a new random number generator using an int array seed.
    `protected` | `AbstractWell(int k, int m1, int m2, int m3, long seed)` Creates a new random number generator using a single long seed.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected abstract int` | `next(int bits)` Generate next pseudorandom number.
    `void` | `setSeed(int seed)` Reinitialize the generator as if just built with the given int seed.
    `void` | `setSeed(int[] seed)` Reinitialize the generator as if just built with the given int array seed.
    `void` | `setSeed(long seed)` Reinitialize the generator as if just built with the given long seed.

    - ### Methods inherited from class org.apache.commons.math3.random.BitsStreamGenerator

      `clear, nextBoolean, nextBytes, nextDouble, nextFloat, nextGaussian, nextInt, nextInt, nextLong`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### serialVersionUID

          private static final long serialVersionUID

      Serializable version identifier.
      See Also:
        Constant Field Values

    - #### index

          protected int index

      Current index in the bytes pool.

    - #### v

          protected final int[] v

      Bytes pool.

    - #### iRm1

          protected final int[] iRm1

      Index indirection table giving for each index its predecessor taking table size into account.

    - #### iRm2

          protected final int[] iRm2

      Index indirection table giving for each index its second predecessor taking table size into account.

    - #### i1

          protected final int[] i1

      Index indirection table giving for each index the value index + m1 taking table size into account.

    - #### i2

          protected final int[] i2

      Index indirection table giving for each index the value index + m2 taking table size into account.

    - #### i3

          protected final int[] i3

      Index indirection table giving for each index the value index + m3 taking table size into account.

  - ### Constructor Detail

    - #### AbstractWell

          protected AbstractWell(int k,
                      int m1,
                      int m2,
                      int m3)

      Creates a new random number generator.

      The instance is initialized using the current time plus the system identity hash code of this instance as the seed.

      Parameters:
        `k` - number of bits in the pool (not necessarily a multiple of 32)
        `m1` - first parameter of the algorithm
        `m2` - second parameter of the algorithm
        `m3` - third parameter of the algorithm

    - #### AbstractWell

          protected AbstractWell(int k,
                      int m1,
                      int m2,
                      int m3,
                      int seed)

      Creates a new random number generator using a single int seed.
      Parameters:
        `k` - number of bits in the pool (not necessarily a multiple of 32)
        `m1` - first parameter of the algorithm
        `m2` - second parameter of the algorithm
        `m3` - third parameter of the algorithm
        `seed` - the initial seed (32 bits integer)

    - #### AbstractWell

          protected AbstractWell(int k,
                      int m1,
                      int m2,
                      int m3,
                      int[] seed)

      Creates a new random number generator using an int array seed.
      Parameters:
        `k` - number of bits in the pool (not necessarily a multiple of 32)
        `m1` - first parameter of the algorithm
        `m2` - second parameter of the algorithm
        `m3` - third parameter of the algorithm
        `seed` - the initial seed (32 bits integers array), if null the seed of the generator will be related to the current time

    - #### AbstractWell

          protected AbstractWell(int k,
                      int m1,
                      int m2,
                      int m3,
                      long seed)

      Creates a new random number generator using a single long seed.
      Parameters:
        `k` - number of bits in the pool (not necessarily a multiple of 32)
        `m1` - first parameter of the algorithm
        `m2` - second parameter of the algorithm
        `m3` - third parameter of the algorithm
        `seed` - the initial seed (64 bits integer)

  - ### Method Detail

    - #### setSeed

          public void setSeed(int seed)

      Reinitialize the generator as if just built with the given int seed.

      The state of the generator is exactly the same as a new generator built with the same seed.

      Specified by:
        `setSeed` in interface `RandomGenerator`
      Specified by:
        `setSeed` in class `BitsStreamGenerator`
      Parameters:
        `seed` - the initial seed (32 bits integer)

    - #### setSeed

          public void setSeed(int[] seed)

      Reinitialize the generator as if just built with the given int array seed.

      The state of the generator is exactly the same as a new generator built with the same seed.

      Specified by:
        `setSeed` in interface `RandomGenerator`
      Specified by:
        `setSeed` in class `BitsStreamGenerator`
      Parameters:
        `seed` - the initial seed (32 bits integers array). If null the seed of the generator will be the system time plus the system identity hash code of the instance.

    - #### setSeed

          public void setSeed(long seed)

      Reinitialize the generator as if just built with the given long seed.

      The state of the generator is exactly the same as a new generator built with the same seed.

      Specified by:
        `setSeed` in interface `RandomGenerator`
      Specified by:
        `setSeed` in class `BitsStreamGenerator`
      Parameters:
        `seed` - the initial seed (64 bits integer)

    - #### next

          protected abstract int next(int bits)

      Generate next pseudorandom number.

      This method is the core generation algorithm. It is used by all the public generation methods for the various primitive types `BitsStreamGenerator.nextBoolean()`, `BitsStreamGenerator.nextBytes(byte[])`, `BitsStreamGenerator.nextDouble()`, `BitsStreamGenerator.nextFloat()`, `BitsStreamGenerator.nextGaussian()`, `BitsStreamGenerator.nextInt()`, `BitsStreamGenerator.next(int)` and `BitsStreamGenerator.nextLong()`.

      Specified by:
        `next` in class `BitsStreamGenerator`
      Parameters:
        `bits` - number of random bits to produce
      Returns:
        random bits generated

Copyright (c) 2003-2013 Apache Software Foundation